Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -1944,24 +2172,27 @@
 void Tesselation::PrintAllBoundaryPoints(ofstream *out) const
 {
+	Info FunctionInfo(__func__);
   // print all lines
-  Log() << Verbose(1) << "Printing all boundary points for debugging:" << endl;
+  Log() << Verbose(0) << "Printing all boundary points for debugging:" << endl;
   for (PointMap::const_iterator PointRunner = PointsOnBoundary.begin();PointRunner != PointsOnBoundary.end(); PointRunner++)
-    Log() << Verbose(2) << *(PointRunner->second) << endl;
+    Log() << Verbose(0) << *(PointRunner->second) << endl;
 };
 
 void Tesselation::PrintAllBoundaryLines(ofstream *out) const
 {
+	Info FunctionInfo(__func__);
   // print all lines
-  Log() << Verbose(1) << "Printing all boundary lines for debugging:" << endl;
+  Log() << Verbose(0) << "Printing all boundary lines for debugging:" << endl;
   for (LineMap::const_iterator LineRunner = LinesOnBoundary.begin(); LineRunner != LinesOnBoundary.end(); LineRunner++)
-    Log() << Verbose(2) << *(LineRunner->second) << endl;
+    Log() << Verbose(0) << *(LineRunner->second) << endl;
 };
 
 void Tesselation::PrintAllBoundaryTriangles(ofstream *out) const
 {
+	Info FunctionInfo(__func__);
   // print all triangles
-  Log() << Verbose(1) << "Printing all boundary triangles for debugging:" << endl;
+  Log() << Verbose(0) << "Printing all boundary triangles for debugging:" << endl;
   for (TriangleMap::const_iterator TriangleRunner = TrianglesOnBoundary.begin(); TriangleRunner != TrianglesOnBoundary.end(); TriangleRunner++)
-    Log() << Verbose(2) << *(TriangleRunner->second) << endl;
+    Log() << Verbose(0) << *(TriangleRunner->second) << endl;
 };
 
@@ -1973,4 +2204,5 @@
 double Tesselation::PickFarthestofTwoBaselines(class BoundaryLineSet *Base)
 {
+	Info FunctionInfo(__func__);
   class BoundaryLineSet *OtherBase;
   Vector *ClosestPoint[2];
@@ -1984,6 +2216,6 @@
   OtherBase = new class BoundaryLineSet(BPS,-1);
 
-  Log() << Verbose(3) << "INFO: Current base line is " << *Base << "." << endl;
-  Log() << Verbose(3) << "INFO: Other base line is " << *OtherBase << "." << endl;
+  Log() << Verbose(0) << "INFO: Current base line is " << *Base << "." << endl;
+  Log() << Verbose(0) << "INFO: Other base line is " << *OtherBase << "." << endl;
 
   // get the closest point on each line to the other line
@@ -2005,5 +2237,5 @@
 
   if (Distance.NormSquared() < MYEPSILON) { // check for intersection
-    Log() << Verbose(3) << "REJECT: Both lines have an intersection: Nothing to do." << endl;
+    Log() << Verbose(0) << "REJECT: Both lines have an intersection: Nothing to do." << endl;
     return false;
   } else { // check for sign against BaseLineNormal
@@ -2011,9 +2243,9 @@
     BaseLineNormal.Zero();
     if (Base->triangles.size() < 2) {
-      Log() << Verbose(2) << "ERROR: Less than two triangles are attached to this baseline!" << endl;
+      eLog() << Verbose(1) << "Less than two triangles are attached to this baseline!" << endl;
       return 0.;
     }
     for (TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++) {
-      Log() << Verbose(4) << "INFO: Adding NormalVector " << runner->second->NormalVector << " of triangle " << *(runner->second) << "." << endl;
+      Log() << Verbose(1) << "INFO: Adding NormalVector " << runner->second->NormalVector << " of triangle " << *(runner->second) << "." << endl;
       BaseLineNormal.AddVector(&(runner->second->NormalVector));
     }
@@ -2021,9 +2253,9 @@
 
     if (Distance.ScalarProduct(&BaseLineNormal) > MYEPSILON) { // Distance points outwards, hence OtherBase higher than Base -> flip
-      Log() << Verbose(2) << "ACCEPT: Other base line would be higher: Flipping baseline." << endl;
+      Log() << Verbose(0) << "ACCEPT: Other base line would be higher: Flipping baseline." << endl;
       // calculate volume summand as a general tetraeder
       return volume;
     } else {  // Base higher than OtherBase -> do nothing
-      Log() << Verbose(2) << "REJECT: Base line is higher: Nothing to do." << endl;
+      Log() << Verbose(0) << "REJECT: Base line is higher: Nothing to do." << endl;
       return 0.;
     }
@@ -2040,4 +2272,5 @@
 class BoundaryLineSet * Tesselation::FlipBaseline(class BoundaryLineSet *Base)
 {
+	Info FunctionInfo(__func__);
   class BoundaryLineSet *OldLines[4], *NewLine;
   class BoundaryPointSet *OldPoints[2];
@@ -2046,14 +2279,12 @@
   int i,m;
 
-  Log() << Verbose(1) << "Begin of FlipBaseline" << endl;
-
   // calculate NormalVector for later use
   BaseLineNormal.Zero();
   if (Base->triangles.size() < 2) {
-    Log() << Verbose(2) << "ERROR: Less than two triangles are attached to this baseline!" << endl;
+    eLog() << Verbose(1) << "Less than two triangles are attached to this baseline!" << endl;
     return NULL;
   }
   for (TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++) {
-    Log() << Verbose(4) << "INFO: Adding NormalVector " << runner->second->NormalVector << " of triangle " << *(runner->second) << "." << endl;
+    Log() << Verbose(1) << "INFO: Adding NormalVector " << runner->second->NormalVector << " of triangle " << *(runner->second) << "." << endl;
     BaseLineNormal.AddVector(&(runner->second->NormalVector));
   }
@@ -2068,5 +2299,5 @@
   i=0;
   m=0;
-  Log() << Verbose(3) << "The four old lines are: ";
+  Log() << Verbose(0) << "The four old lines are: ";
   for(TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++)
     for (int j=0;j<3;j++) // all of their endpoints and baselines
@@ -2076,5 +2307,5 @@
       }
   Log() << Verbose(0) << endl;
-  Log() << Verbose(3) << "The two old points are: ";
+  Log() << Verbose(0) << "The two old points are: ";
   for(TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++)
     for (int j=0;j<3;j++) // all of their endpoints and baselines
@@ -2087,24 +2318,24 @@
   // check whether everything is in place to create new lines and triangles
   if (i<4) {
-    Log() << Verbose(1) << "ERROR: We have not gathered enough baselines!" << endl;
+    eLog() << Verbose(1) << "We have not gathered enough baselines!" << endl;
     return NULL;
   }
   for (int j=0;j<4;j++)
     if (OldLines[j] == NULL) {
-      Log() << Verbose(1) << "ERROR: We have not gathered enough baselines!" << endl;
+      eLog() << Verbose(1) << "We have not gathered enough baselines!" << endl;
       return NULL;
     }
   for (int j=0;j<2;j++)
     if (OldPoints[j] == NULL) {
-      Log() << Verbose(1) << "ERROR: We have not gathered enough endpoints!" << endl;
+      eLog() << Verbose(1) << "We have not gathered enough endpoints!" << endl;
       return NULL;
     }
 
   // remove triangles and baseline removes itself
-  Log() << Verbose(3) << "INFO: Deleting baseline " << *Base << " from global list." << endl;
+  Log() << Verbose(0) << "INFO: Deleting baseline " << *Base << " from global list." << endl;
   OldBaseLineNr = Base->Nr;
   m=0;
   for(TriangleMap::iterator runner = Base->triangles.begin(); runner != Base->triangles.end(); runner++) {
-    Log() << Verbose(3) << "INFO: Deleting triangle " << *(runner->second) << "." << endl;
+    Log() << Verbose(0) << "INFO: Deleting triangle " << *(runner->second) << "." << endl;
     OldTriangleNrs[m++] = runner->second->Nr;
     RemoveTesselationTriangle(runner->second);
@@ -2116,5 +2347,5 @@
   NewLine = new class BoundaryLineSet(BPS, OldBaseLineNr);
   LinesOnBoundary.insert(LinePair(OldBaseLineNr, NewLine)); // no need for check for unique insertion as NewLine is definitely a new one
-  Log() << Verbose(3) << "INFO: Created new baseline " << *NewLine << "." << endl;
+  Log() << Verbose(0) << "INFO: Created new baseline " << *NewLine << "." << endl;
 
   // construct new triangles with flipped baseline
@@ -2131,5 +2362,5 @@
     BTS->GetNormalVector(BaseLineNormal);
     AddTesselationTriangle(OldTriangleNrs[0]);
-    Log() << Verbose(3) << "INFO: Created new triangle " << *BTS << "." << endl;
+    Log() << Verbose(0) << "INFO: Created new triangle " << *BTS << "." << endl;
 
     BLS[0] = (i==2 ? OldLines[3] : OldLines[2]);
@@ -2139,11 +2370,10 @@
     BTS->GetNormalVector(BaseLineNormal);
     AddTesselationTriangle(OldTriangleNrs[1]);
-    Log() << Verbose(3) << "INFO: Created new triangle " << *BTS << "." << endl;
+    Log() << Verbose(0) << "INFO: Created new triangle " << *BTS << "." << endl;
   } else {
-    Log() << Verbose(1) << "The four old lines do not connect, something's utterly wrong here!" << endl;
+    eLog() << Verbose(0) << "The four old lines do not connect, something's utterly wrong here!" << endl;
     return NULL;
   }
 
-  Log() << Verbose(1) << "End of FlipBaseline" << endl;
   return NewLine;
 };
@@ -2160,5 +2390,5 @@
 void Tesselation::FindSecondPointForTesselation(TesselPoint* a, Vector Oben, TesselPoint*& OptCandidate, double Storage[3], double RADIUS, const LinkedCell *LC)
 {
-  Log() << Verbose(2) << "Begin of FindSecondPointForTesselation" << endl;
+	Info FunctionInfo(__func__);
   Vector AngleCheck;
   class TesselPoint* Candidate = NULL;
@@ -2173,20 +2403,14 @@
       N[i] = LC->n[i];
   } else {
-    eLog() << Verbose(0) << "ERROR: Point " << *a << " is not found in cell " << LC->index << "." << endl;
+    eLog() << Verbose(1) << "Point " << *a << " is not found in cell " << LC->index << "." << endl;
     return;
   }
   // then go through the current and all neighbouring cells and check the contained points for possible candidates
-  Log() << Verbose(3) << "LC Intervals from [";
-  for (int i=0;i<NDIM;i++) {
-  Log() << Verbose(0) << " " << N[i] << "<->" << LC->N[i];
-  }
-  Log() << Verbose(0) << "] :";
   for (int i=0;i<NDIM;i++) {
     Nlower[i] = ((N[i]-1) >= 0) ? N[i]-1 : 0;
     Nupper[i] = ((N[i]+1) < LC->N[i]) ? N[i]+1 : LC->N[i]-1;
-    Log() << Verbose(0) << " [" << Nlower[i] << "," << Nupper[i] << "] ";
-  }
-  Log() << Verbose(0) << endl;
-
+  }
+  Log() << Verbose(0) << "LC Intervals from [" << N[0] << "<->" << LC->N[0] << ", " << N[1] << "<->" << LC->N[1] << ", " << N[2] << "<->" << LC->N[2] << "] :"
+    << " [" << Nlower[0] << "," << Nupper[0] << "], " << " [" << Nlower[1] << "," << Nupper[1] << "], " << " [" << Nlower[2] << "," << Nupper[2] << "], " << endl;
 
   for (LC->n[0] = Nlower[0]; LC->n[0] <= Nupper[0]; LC->n[0]++)
@@ -2194,5 +2418,5 @@
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
         const LinkedNodes *List = LC->GetCurrentCell();
-        //Log() << Verbose(2) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
+        //Log() << Verbose(1) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
         if (List != NULL) {
           for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
@@ -2225,24 +2449,23 @@
                 angle = AngleCheck.Angle(&Oben);
                 if (angle < Storage[0]) {
-                  //Log() << Verbose(3) << "Old values of Storage: %lf %lf \n", Storage[0], Storage[1]);
-                  Log() << Verbose(3) << "Current candidate is " << *Candidate << ": Is a better candidate with distance " << norm << " and angle " << angle << " to oben " << Oben << ".\n";
+                  //Log() << Verbose(1) << "Old values of Storage: %lf %lf \n", Storage[0], Storage[1]);
+                  Log() << Verbose(1) << "Current candidate is " << *Candidate << ": Is a better candidate with distance " << norm << " and angle " << angle << " to oben " << Oben << ".\n";
                   OptCandidate = Candidate;
                   Storage[0] = angle;
-                  //Log() << Verbose(3) << "Changing something in Storage: %lf %lf. \n", Storage[0], Storage[2]);
+                  //Log() << Verbose(1) << "Changing something in Storage: %lf %lf. \n", Storage[0], Storage[2]);
                 } else {
-                  //Log() << Verbose(3) << "Current candidate is " << *Candidate << ": Looses with angle " << angle << " to a better candidate " << *OptCandidate << endl;
+                  //Log() << Verbose(1) << "Current candidate is " << *Candidate << ": Looses with angle " << angle << " to a better candidate " << *OptCandidate << endl;
                 }
               } else {
-                //Log() << Verbose(3) << "Current candidate is " << *Candidate << ": Refused due to Radius " << norm << endl;
+                //Log() << Verbose(1) << "Current candidate is " << *Candidate << ": Refused due to Radius " << norm << endl;
               }
             } else {
-              //Log() << Verbose(3) << "Current candidate is " << *Candidate << ": Candidate is equal to first endpoint." << *a << "." << endl;
+              //Log() << Verbose(1) << "Current candidate is " << *Candidate << ": Candidate is equal to first endpoint." << *a << "." << endl;
             }
           }
         } else {
-          Log() << Verbose(3) << "Linked cell list is empty." << endl;
+          Log() << Verbose(0) << "Linked cell list is empty." << endl;
         }
       }
-  Log() << Verbose(2) << "End of FindSecondPointForTesselation" << endl;
 };
 
@@ -2273,13 +2496,12 @@
  * @param SearchDirection general direction where to search for the next point, relative to center of BaseLine
  * @param OldSphereCenter center of sphere for base triangle, relative to center of BaseLine, giving null angle for the parameter circle
- * @param BaseLine BoundaryLineSet with the current base line
+ * @param CandidateLine CandidateForTesselation with the current base line and list of candidates and ShortestAngle
  * @param ThirdNode third point to avoid in search
- * @param candidates list of equally good candidates to return
- * @param ShortestAngle the current path length on this circle band for the current OptCandidate
  * @param RADIUS radius of sphere
  * @param *LC LinkedCell structure with neighbouring points
  */
-void Tesselation::FindThirdPointForTesselation(Vector NormalVector, Vector SearchDirection, Vector OldSphereCenter, class BoundaryLineSet *BaseLine, class TesselPoint  *ThirdNode, CandidateList* &candidates, double *ShortestAngle, const double RADIUS, const LinkedCell *LC)
-{
+void Tesselation::FindThirdPointForTesselation(Vector &NormalVector, Vector &SearchDirection, Vector &OldSphereCenter, CandidateForTesselation &CandidateLine, const class TesselPoint  * const ThirdNode, const double RADIUS, const LinkedCell *LC) const
+{
+	Info FunctionInfo(__func__);
   Vector CircleCenter;  // center of the circle, i.e. of the band of sphere's centers
   Vector CirclePlaneNormal; // normal vector defining the plane this circle lives in
@@ -2294,18 +2516,15 @@
   int N[NDIM], Nlower[NDIM], Nupper[NDIM];
   TesselPoint *Candidate = NULL;
-  CandidateForTesselation *optCandidate = NULL;
-
-  Log() << Verbose(1) << "Begin of FindThirdPointForTesselation" << endl;
-
-  Log() << Verbose(2) << "INFO: NormalVector of BaseTriangle is " << NormalVector << "." << endl;
+
+  Log() << Verbose(1) << "INFO: NormalVector of BaseTriangle is " << NormalVector << "." << endl;
 
   // construct center of circle
-  CircleCenter.CopyVector(BaseLine->endpoints[0]->node->node);
-  CircleCenter.AddVector(BaseLine->endpoints[1]->node->node);
+  CircleCenter.CopyVector(CandidateLine.BaseLine->endpoints[0]->node->node);
+  CircleCenter.AddVector(CandidateLine.BaseLine->endpoints[1]->node->node);
   CircleCenter.Scale(0.5);
 
   // construct normal vector of circle
-  CirclePlaneNormal.CopyVector(BaseLine->endpoints[0]->node->node);
-  CirclePlaneNormal.SubtractVector(BaseLine->endpoints[1]->node->node);
+  CirclePlaneNormal.CopyVector(CandidateLine.BaseLine->endpoints[0]->node->node);
+  CirclePlaneNormal.SubtractVector(CandidateLine.BaseLine->endpoints[1]->node->node);
 
   // calculate squared radius TesselPoint *ThirdNode,f circle
@@ -2314,19 +2533,19 @@
     CircleRadius = RADIUS*RADIUS - radius/4.;
     CirclePlaneNormal.Normalize();
-    //Log() << Verbose(2) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl;
+    //Log() << Verbose(1) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl;
 
     // test whether old center is on the band's plane
     if (fabs(OldSphereCenter.ScalarProduct(&CirclePlaneNormal)) > HULLEPSILON) {
-      eLog() << Verbose(0) << "ERROR: Something's very wrong here: OldSphereCenter is not on the band's plane as desired by " << fabs(OldSphereCenter.ScalarProduct(&CirclePlaneNormal)) << "!" << endl;
+      eLog() << Verbose(1) << "Something's very wrong here: OldSphereCenter is not on the band's plane as desired by " << fabs(OldSphereCenter.ScalarProduct(&CirclePlaneNormal)) << "!" << endl;
       OldSphereCenter.ProjectOntoPlane(&CirclePlaneNormal);
     }
     radius = OldSphereCenter.ScalarProduct(&OldSphereCenter);
     if (fabs(radius - CircleRadius) < HULLEPSILON) {
-      //Log() << Verbose(2) << "INFO: OldSphereCenter is at " << OldSphereCenter << "." << endl;
+      //Log() << Verbose(1) << "INFO: OldSphereCenter is at " << OldSphereCenter << "." << endl;
 
       // check SearchDirection
-      //Log() << Verbose(2) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
+      //Log() << Verbose(1) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
       if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {  // rotated the wrong way!
-        eLog() << Verbose(0) << "ERROR: SearchDirection and RelativeOldSphereCenter are not orthogonal!" << endl;
+        eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are not orthogonal!" << endl;
       }
 
@@ -2335,11 +2554,11 @@
         for(int i=0;i<NDIM;i++) // store indices of this cell
         N[i] = LC->n[i];
-        //Log() << Verbose(2) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+        //Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
       } else {
-        eLog() << Verbose(0) << "ERROR: Vector " << CircleCenter << " is outside of LinkedCell's bounding box." << endl;
+        eLog() << Verbose(1) << "Vector " << CircleCenter << " is outside of LinkedCell's bounding box." << endl;
         return;
       }
       // then go through the current and all neighbouring cells and check the contained points for possible candidates
-      //Log() << Verbose(2) << "LC Intervals:";
+      //Log() << Verbose(1) << "LC Intervals:";
       for (int i=0;i<NDIM;i++) {
         Nlower[i] = ((N[i]-1) >= 0) ? N[i]-1 : 0;
@@ -2352,5 +2571,5 @@
           for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
             const LinkedNodes *List = LC->GetCurrentCell();
-            //Log() << Verbose(2) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
+            //Log() << Verbose(1) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
             if (List != NULL) {
               for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
@@ -2358,23 +2577,23 @@
 
                 // check for three unique points
-                //Log() << Verbose(2) << "INFO: Current Candidate is " << *Candidate << " at " << Candidate->node << "." << endl;
-                if ((Candidate != BaseLine->endpoints[0]->node) && (Candidate != BaseLine->endpoints[1]->node) ){
+                Log() << Verbose(2) << "INFO: Current Candidate is " << *Candidate << " at " << *(Candidate->node) << "." << endl;
+                if ((Candidate != CandidateLine.BaseLine->endpoints[0]->node) && (Candidate != CandidateLine.BaseLine->endpoints[1]->node) ){
 
                   // construct both new centers
-                  GetCenterofCircumcircle(&NewSphereCenter, *BaseLine->endpoints[0]->node->node, *BaseLine->endpoints[1]->node->node, *Candidate->node);
+                  GetCenterofCircumcircle(&NewSphereCenter, *CandidateLine.BaseLine->endpoints[0]->node->node, *CandidateLine.BaseLine->endpoints[1]->node->node, *Candidate->node);
                   OtherNewSphereCenter.CopyVector(&NewSphereCenter);
 
-                  if ((NewNormalVector.MakeNormalVector(BaseLine->endpoints[0]->node->node, BaseLine->endpoints[1]->node->node, Candidate->node))
+                  if ((NewNormalVector.MakeNormalVector(CandidateLine.BaseLine->endpoints[0]->node->node, CandidateLine.BaseLine->endpoints[1]->node->node, Candidate->node))
                   && (fabs(NewNormalVector.ScalarProduct(&NewNormalVector)) > HULLEPSILON)
                   ) {
                     helper.CopyVector(&NewNormalVector);
-                    //Log() << Verbose(2) << "INFO: NewNormalVector is " << NewNormalVector << "." << endl;
-                    radius = BaseLine->endpoints[0]->node->node->DistanceSquared(&NewSphereCenter);
+                    Log() << Verbose(1) << "INFO: NewNormalVector is " << NewNormalVector << "." << endl;
+                    radius = CandidateLine.BaseLine->endpoints[0]->node->node->DistanceSquared(&NewSphereCenter);
                     if (radius < RADIUS*RADIUS) {
                       helper.Scale(sqrt(RADIUS*RADIUS - radius));
-                      //Log() << Verbose(2) << "INFO: Distance of NewCircleCenter to NewSphereCenter is " << helper.Norm() << " with sphere radius " << RADIUS << "." << endl;
+                      Log() << Verbose(2) << "INFO: Distance of NewCircleCenter to NewSphereCenter is " << helper.Norm() << " with sphere radius " << RADIUS << "." << endl;
                       NewSphereCenter.AddVector(&helper);
                       NewSphereCenter.SubtractVector(&CircleCenter);
-                      //Log() << Verbose(2) << "INFO: NewSphereCenter is at " << NewSphereCenter << "." << endl;
+                      Log() << Verbose(2) << "INFO: NewSphereCenter is at " << NewSphereCenter << "." << endl;
 
                       // OtherNewSphereCenter is created by the same vector just in the other direction
@@ -2382,5 +2601,5 @@
                       OtherNewSphereCenter.AddVector(&helper);
                       OtherNewSphereCenter.SubtractVector(&CircleCenter);
-                      //Log() << Verbose(2) << "INFO: OtherNewSphereCenter is at " << OtherNewSphereCenter << "." << endl;
+                      Log() << Verbose(2) << "INFO: OtherNewSphereCenter is at " << OtherNewSphereCenter << "." << endl;
 
                       alpha = GetPathLengthonCircumCircle(CircleCenter, CirclePlaneNormal, CircleRadius, NewSphereCenter, OldSphereCenter, NormalVector, SearchDirection);
@@ -2389,51 +2608,45 @@
                       // if there is a better candidate, drop the current list and add the new candidate
                       // otherwise ignore the new candidate and keep the list
-                      if (*ShortestAngle > (alpha - HULLEPSILON)) {
-                        optCandidate = new CandidateForTesselation(Candidate, BaseLine, OptCandidateCenter, OtherOptCandidateCenter);
+                      if (CandidateLine.ShortestAngle > (alpha - HULLEPSILON)) {
                         if (fabs(alpha - Otheralpha) > MYEPSILON) {
-                          optCandidate->OptCenter.CopyVector(&NewSphereCenter);
-                          optCandidate->OtherOptCenter.CopyVector(&OtherNewSphereCenter);
+                          CandidateLine.OptCenter.CopyVector(&NewSphereCenter);
+                          CandidateLine.OtherOptCenter.CopyVector(&OtherNewSphereCenter);
                         } else {
-                          optCandidate->OptCenter.CopyVector(&OtherNewSphereCenter);
-                          optCandidate->OtherOptCenter.CopyVector(&NewSphereCenter);
+                          CandidateLine.OptCenter.CopyVector(&OtherNewSphereCenter);
+                          CandidateLine.OtherOptCenter.CopyVector(&NewSphereCenter);
                         }
                         // if there is an equal candidate, add it to the list without clearing the list
-                        if ((*ShortestAngle - HULLEPSILON) < alpha) {
-                          candidates->push_back(optCandidate);
-                          Log() << Verbose(2) << "ACCEPT: We have found an equally good candidate: " << *(optCandidate->point) << " with "
-                            << alpha << " and circumsphere's center at " << optCandidate->OptCenter << "." << endl;
+                        if ((CandidateLine.ShortestAngle - HULLEPSILON) < alpha) {
+                          CandidateLine.pointlist.push_back(Candidate);
+                          Log() << Verbose(0) << "ACCEPT: We have found an equally good candidate: " << *(Candidate) << " with "
+                            << alpha << " and circumsphere's center at " << CandidateLine.OptCenter << "." << endl;
                         } else {
                           // remove all candidates from the list and then the list itself
-                          class CandidateForTesselation *remover = NULL;
-                          for (CandidateList::iterator it = candidates->begin(); it != candidates->end(); ++it) {
-                            remover = *it;
-                            delete(remover);
-                          }
-                          candidates->clear();
-                          candidates->push_back(optCandidate);
-                          Log() << Verbose(2) << "ACCEPT: We have found a better candidate: " << *(optCandidate->point) << " with "
-                            << alpha << " and circumsphere's center at " << optCandidate->OptCenter << "." << endl;
+                          CandidateLine.pointlist.clear();
+                          CandidateLine.pointlist.push_back(Candidate);
+                          Log() << Verbose(0) << "ACCEPT: We have found a better candidate: " << *(Candidate) << " with "
+                            << alpha << " and circumsphere's center at " << CandidateLine.OptCenter << "." << endl;
                         }
-                        *ShortestAngle = alpha;
-                        //Log() << Verbose(2) << "INFO: There are " << candidates->size() << " candidates in the list now." << endl;
+                        CandidateLine.ShortestAngle = alpha;
+                        Log() << Verbose(0) << "INFO: There are " << CandidateLine.pointlist.size() << " candidates in the list now." << endl;
                       } else {
-                        if ((optCandidate != NULL) && (optCandidate->point != NULL)) {
-                          //Log() << Verbose(2) << "REJECT: Old candidate " << *(optCandidate->point) << " with " << *ShortestAngle << " is better than new one " << *Candidate << " with " << alpha << " ." << endl;
+                        if ((Candidate != NULL) && (CandidateLine.pointlist.begin() != CandidateLine.pointlist.end())) {
+                          Log() << Verbose(1) << "REJECT: Old candidate " << *(Candidate) << " with " << CandidateLine.ShortestAngle << " is better than new one " << *Candidate << " with " << alpha << " ." << endl;
                         } else {
-                          //Log() << Verbose(2) << "REJECT: Candidate " << *Candidate << " with " << alpha << " was rejected." << endl;
+                          Log() << Verbose(1) << "REJECT: Candidate " << *Candidate << " with " << alpha << " was rejected." << endl;
                         }
                       }
 
                     } else {
-                      //Log() << Verbose(2) << "REJECT: NewSphereCenter " << NewSphereCenter << " for " << *Candidate << " is too far away: " << radius << "." << endl;
+                      Log() << Verbose(1) << "REJECT: NewSphereCenter " << NewSphereCenter << " for " << *Candidate << " is too far away: " << radius << "." << endl;
                     }
                   } else {
-                    //Log() << Verbose(2) << "REJECT: Three points from " << *BaseLine << " and Candidate " << *Candidate << " are linear-dependent." << endl;
+                    Log() << Verbose(1) << "REJECT: Three points from " << *CandidateLine.BaseLine << " and Candidate " << *Candidate << " are linear-dependent." << endl;
                   }
                 } else {
                   if (ThirdNode != NULL) {
-                    //Log() << Verbose(2) << "REJECT: Base triangle " << *BaseLine << " and " << *ThirdNode << " contains Candidate " << *Candidate << "." << endl;
+                    Log() << Verbose(1) << "REJECT: Base triangle " << *CandidateLine.BaseLine << " and " << *ThirdNode << " contains Candidate " << *Candidate << "." << endl;
                   } else {
-                    //Log() << Verbose(2) << "REJECT: Base triangle " << *BaseLine << " contains Candidate " << *Candidate << "." << endl;
+                    Log() << Verbose(1) << "REJECT: Base triangle " << *CandidateLine.BaseLine << " contains Candidate " << *Candidate << "." << endl;
                   }
                 }
@@ -2442,20 +2655,18 @@
           }
     } else {
-      eLog() << Verbose(2) << "ERROR: The projected center of the old sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
+      eLog() << Verbose(1) << "The projected center of the old sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
     }
   } else {
     if (ThirdNode != NULL)
-      Log() << Verbose(2) << "Circumcircle for base line " << *BaseLine << " and third node " << *ThirdNode << " is too big!" << endl;
+      Log() << Verbose(1) << "Circumcircle for base line " << *CandidateLine.BaseLine << " and third node " << *ThirdNode << " is too big!" << endl;
     else
-      Log() << Verbose(2) << "Circumcircle for base line " << *BaseLine << " is too big!" << endl;
-  }
-
-  //Log() << Verbose(2) << "INFO: Sorting candidate list ..." << endl;
-  if (candidates->size() > 1) {
-    candidates->unique();
-    candidates->sort(SortCandidates);
-  }
-
-  Log() << Verbose(1) << "End of FindThirdPointForTesselation" << endl;
+      Log() << Verbose(1) << "Circumcircle for base line " << *CandidateLine.BaseLine << " is too big!" << endl;
+  }
+
+  Log() << Verbose(1) << "INFO: Sorting candidate list ..." << endl;
+  if (CandidateLine.pointlist.size() > 1) {
+    CandidateLine.pointlist.unique();
+    CandidateLine.pointlist.sort(); //SortCandidates);
+  }
 };
 
@@ -2467,4 +2678,5 @@
 class BoundaryPointSet *Tesselation::GetCommonEndpoint(const BoundaryLineSet * line1, const BoundaryLineSet * line2) const
 {
+	Info FunctionInfo(__func__);
   const BoundaryLineSet * lines[2] = { line1, line2 };
   class BoundaryPointSet *node = NULL;
@@ -2480,5 +2692,5 @@
           { // if insertion fails, we have common endpoint
             node = OrderTest.first->second;
-            Log() << Verbose(5) << "Common endpoint of lines " << *line1
+            Log() << Verbose(1) << "Common endpoint of lines " << *line1
                 << " and " << *line2 << " is: " << *node << "." << endl;
             j = 2;
@@ -2497,4 +2709,5 @@
 list<BoundaryTriangleSet*> * Tesselation::FindClosestTrianglesToPoint(const Vector *x, const LinkedCell* LC) const
 {
+	Info FunctionInfo(__func__);
   TesselPoint *trianglePoints[3];
   TesselPoint *SecondPoint = NULL;
